class TheMatrix001 {

  // Buntich Demo Stuff
  
  final int pix_w = 16;
  final int pix_h = 8;
  
  int[] mtx_y     = new int [pix_w];
  int[] mtx_delay = new int [pix_w];
  int[] mtx_speed = new int [pix_w];
  
  final int mtx_jump = 200;
  final int mtx_speed_min = 1;
  final int mtx_speed_max = 10;
  
  final int mtx_delay_min = 10;
  final int mtx_delay_max = 200;
  
  final int mtx_fade_in = 64;
  final int mtx_fade_out = 4;
  
  int[][] cr = new int [pix_w][pix_h];
  int[][] cg = new int [pix_w][pix_h];
  int[][] cb = new int [pix_w][pix_h];
  
  
  void setup () {
    int i;
  
    for (i = 0; i < pix_w; i ++) {
      mtx_y[i] = -1;
      mtx_delay[i] = int(random(mtx_delay_min, mtx_delay_max));
      mtx_speed[i] = int(random(mtx_speed_min, mtx_speed_max));
    }
  
  
     frameRate(40);
  
  
    background(0);
  
  }
  
  int cr0, cg0, cb0;
  int countdown = 0;
  
  void draw () {
    int x, y;
  
    for (x = 0; x < pix_w; x ++) {
      if (mtx_y[x] < 0) {
        mtx_delay[x] --;
        if (mtx_delay[x] < 0) {
          mtx_y[x] = 0;
          mtx_speed[x] = int(random(mtx_speed_min, mtx_speed_max));
        }
      }
      else {
        if (random(mtx_speed_min, mtx_speed_max) >= mtx_speed[x])
          mtx_y[x] ++;
        if (mtx_y[x] >= pix_h) {
          mtx_y[x] = -1;
          mtx_delay[x] = int(random(mtx_delay_min, mtx_delay_max));
        }
      }
  
      for (y = 0; y < pix_h; y ++) {
        if (y == mtx_y[x])
          cr[x][y] = min(255, cr[x][y] + mtx_fade_in);
        else
          cr[x][y] = max(0, cr[x][y] - mtx_fade_out);
  
        stroke(cr[x][y] / 4, cr[x][y], cr[x][y] / 4);
        point(x, y);
      }
    }
  
    bt.display();
  }

}

