class Bunt1 {
  PFont fontA;
  float moverX = 0;
  float colorhue = 0;
  float colorsat = 0;
  
  void setup() {
    background(0);
    fontA = loadFont("LucidaConsole-8.vlw");
    textFont(fontA);
  }
  
  void draw() {
    background(0);
    colorMode(HSB);
    float r;
    for(r = 0; r<360.0; r+=5.0) {
      
      stroke((colorhue * 255 + (r/360.0)*256)%256,(colorsat * 255 + (r/360.0)*64)%256,255);
      line(7.5,4.5,7.5+sin(radians(r))*10.5,4.5+cos(radians(r))*10);
    }
    moverX -= 0.1;
    if(moverX < -150) moverX = 16;
    colorhue += 0.01;
    if(colorhue > 1.0) colorhue = 0.0;
    colorsat += 0.001;
    if(colorsat > 1.0) colorsat = 0.0;
  
    fill(0);
    //text("Buntich HACKERSPACE-FFM", moverX, 6);
  
    colorMode(RGB);
    bt.display(); 
    //println(frameRate);
  }
}


class Bunt_blink {
  int timer = 0;
  
  void setup() {
    background(0);
  }
  
  void draw() {
    timer ++;
    stroke((timer > 20) ? 0 : 255);
    point(4, 4);
    if (timer >= 40)
      timer = 0;
    bt.display(); 
  }
}

class Bunt_black {
  void setup() {
    background(0);
  }
  
  void draw() {
    bt.display(); 
  }
}


class Bunt_bus {
  int timer = 0;
  int t2;
  
  void setup() {
    background(0);
  }
  
  void draw() {
    t2 = timer / 2;
    
    for (int i = 0; i < 16; i ++) {
      if(i == t2)
        stroke(255, 255, 255);
      else
        stroke(64, 0, 0);
      point(i, 1);

      if((i + 10) == t2)
        stroke(255, 255, 255);
      else
        stroke(0, 0, 64);
      point(i, 6);
    }
    timer ++;
    if (timer >= 56)
      timer = 0;
    bt.display(); 
  }
}


class Bunt_farbdemo {
  int timer = 0;
 
  void setup() {
    background(0);
  }
  
  void draw() {
    for (int i = 0; i < 128; i ++) {
      int x = i / 8;
      int y = i % 8;
      int f = 2 * i;
      if (timer < 80)
        stroke(f, 0, 0);
      else
        if (timer < 160)
          stroke(0, f, 0);
        else
          stroke(0, 0, f);
      point(x, y);
    }

    timer ++;
    if (timer >= 240)
      timer = 0;
    bt.display(); 
  }
}


class Bunt_MUX {
  int timer = 0;
  int t2, t2o = 0;
  
  void setup() {
    background(0);
  }
  
  void draw() {
    timer ++;
    t2 = timer / 20;

    if (t2 != t2o) {
      t2o = t2;
      for (int i = 0; i < 128; i ++) {
        int x = i / 8;
        int y = i % 8;
        stroke ((random(0, 20) < t2) ? 255 : 0);
        point(x, y);
      }
    }

    if (timer >= 800)
      timer = 0;
    bt.display(); 
  }
}


class Bunt_EXT {
  int timer = 0;
  
  void setup() {
    background(0);
  }
  
  void draw() {
    timer ++;
//    stroke((timer > 20) ? 128 : 160, (timer > 40) ? 128 : 160, (timer > 60) ? 128 : 160);
    stroke (128);

    for (int i = 0; i < 3; i ++) {
      int j = min(1, i);
      point (2, i);
      point (2, i + 4);

      point (5 + i, 0);
      point (8, j + 1);
      point (6 + j, 3);
      point (5, i + 4);
      point (6 + i, 6);

      point (12 + j, 0);
      point (11, j + 1);
      point (14, j + 1);
      point (12 + j, 3);
      point (11, j + 4);
      point (14, j + 4);
      point (12+ j, 6);
    }
    
    if (timer >= 80)
      timer = 0;
    bt.display(); 
  }
}



